%define		pname libdomainkeys
%define		pversion 0.69
%define 	bversion 4
%define		rpmrelease iworx

# Distro Statements
%define		oscode rhe%{?rhel}x

%if 0%{?rhel} <= 7
%define 	ostype RedHat Enterprise %{?rhel}.x
%endif


%if 0%{?rhel} >= 8
%define 	ostype Almalinux %{?rhel}.x
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

BuildRequires:	openssl-devel
BuildRequires:  perl
Requires:       perl
%define		ccflags %{optflags}
%define		ldflags %{optflags}

############### RPM ################################

Summary:	libdomainkeys domain keys library
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	Yahoo! DomainKeys Public License
Group:		System Environment/Libraries
URL:		http://domainkeys.sourceforge.net/
Source0:	libdomainkeys-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{pversion}-root
Obsoletes:	libdomainkeys
Packager:       Tim College <tcollege@interworx.com>

# Patch0 and Patch1 are from https://notes.sagredo.eu/en/qmail-notes-185/patching-qmail-82.html
Patch0: libdomainkeys-openssl-1.1.patch
Patch1: libdomainkeys-0.69.diff

%define	name libdomainkeys

#------------------------------------------------------------------------------------
%description
#------------------------------------------------------------------------------------
DomainKey Implementor's library.


#------------------------------------------------------------------------------------
%prep
#------------------------------------------------------------------------------------
%setup -q -n %{name}-%{pversion}

%if 0%{?rhel} >= 8
%patch0 -p1
%patch1
%endif

# Display compilation flags and OS with nice colors
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
#------------------------------------------------------------------------------------
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

%if 0%{?rhel} <= 7
perl -pi -e "s/CFLAGS=/CFLAGS=%{optflags} -fPIC /" Makefile
%endif

%if 0%{?rhel} >= 8
# perl 5.26 was behaving differently, so the delimiters needed to change for the regex
perl -pi -e "s#CFLAGS=#CFLAGS=%{optflags} -fPIC #" Makefile
%endif
echo "-lresolv" > dns.lib


#----------------------------------------------------------------------------------
%build
#----------------------------------------------------------------------------------
if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi
mkdir -p %{buildroot}


make UNAME=Linux

#------------------------------------------------------------------------------------
%install
#------------------------------------------------------------------------------------

# install directories
#------------------------------------------------------------------------------------
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_bindir}

# install files
#------------------------------------------------------------------------------------
install -p domainkeys.h dktrace.h %{buildroot}%{_includedir}
install -p libdomainkeys.a %{buildroot}%{_libdir}
install -p dknewkey dktest %{buildroot}%{_bindir}

#------------------------------------------------------------------------------------
%clean
#------------------------------------------------------------------------------------
if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi
if [ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] ; then rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} ; fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: libdomainkeys package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

#------------------------------------------------------------------------------------
%files
#------------------------------------------------------------------------------------
%defattr(-,root,root,-)
%doc README CHANGES *.html
%{_bindir}/*

%{_includedir}/*
%{_libdir}/libdomainkeys.a


#------------------------------------------------------------------------------------
%changelog
#------------------------------------------------------------------------------------
%changelog
* Mon Jan 03 2022 Joseph Purkis <jpurkis@interworx.com>
- Remove ancient dynamic gcc resolution (always resulted in just 'gcc')
- Cleaned up old Distros
* Wed Aug 11 2021 Joseph Purkis <jpurkis@interworx.com>
- Added Almalinux 8.x build
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- added support for Fedora 8
* Fri Mar 21 2008 Paul Oehler <poehler@interworx.com>
- Initial build for InterWorx-CP
